package org.bitbucket.bradleysmithllc.etlunit.feature.database.db;

import org.bitbucket.bradleysmithllc.etlunit.feature.database.RelationalDataSet;

public class TableImpl implements Table
{
	private final Schema schema;
	private final Catalog catalog;
	private final String name;
	private final type type;

	private RelationalDataSet relationalDataSet;

	public TableImpl(Catalog catalog, Schema schema, String name, Table.type type) {
		this.schema = schema;
		this.catalog = catalog;
		this.name = name;
		this.type = type;
	}

	@Override
	public Schema getSchema() {
		return schema;
	}

	@Override
	public Catalog getCatalog() {
		return catalog;
	}

	@Override
	public String getName() {
		return name;
	}

	@Override
	public RelationalDataSet getDataSet() {
		return relationalDataSet;
	}

	public void setRelationalDataSet(RelationalDataSet relationalDataSet) {
		this.relationalDataSet = relationalDataSet;
	}

	@Override
	public type getType() {
		return type;
	}

	@Override
	public String getDBLocalName() {
		StringBuilder stb = new StringBuilder();

		if (catalog.getName() != null)
		{
			stb.append(catalog.getName());
			stb.append('.');
		}

		if (schema.getName() != null)
		{
			stb.append(schema.getName());
			stb.append('.');
		}

		stb.append(name);

		return stb.toString();
	}

	public String toString()
	{
		return (schema == null ? "" : (schema.toString() + ".")) + name;
	}
}